xref: /freebsd/usr.sbin/bsdinstall/scripts/jail (revision 4b9d6057)
1#!/bin/sh
2#-
3# Copyright (c) 2011 Nathan Whitehorn
4# Copyright (c) 2013-2015 Devin Teske
5# All rights reserved.
6#
7# Redistribution and use in source and binary forms, with or without
8# modification, are permitted provided that the following conditions
9# are met:
10# 1. Redistributions of source code must retain the above copyright
11#    notice, this list of conditions and the following disclaimer.
12# 2. Redistributions in binary form must reproduce the above copyright
13#    notice, this list of conditions and the following disclaimer in the
14#    documentation and/or other materials provided with the distribution.
15#
16# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
17# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
18# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
19# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
20# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
21# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
22# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
23# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
24# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
25# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
26# SUCH DAMAGE.
27#
28#
29############################################################ INCLUDES
30
31BSDCFG_SHARE="/usr/share/bsdconfig"
32. $BSDCFG_SHARE/common.subr || exit 1
33
34############################################################ MAIN
35
36: ${BSDDIALOG_OK=0}
37
38f_dprintf "Began Installation at %s" "$( date )"
39
40error() {
41	local msg
42	if [ -n "$1" ]; then
43		msg="$1\n\n"
44	fi
45	bsddialog --backtitle "$OSNAME Installer" --title "Abort" \
46	    --no-label "Exit" --yes-label "Restart" --yesno \
47	    "${msg}An installation step has been aborted. Would you like to restart the installation or exit the installer?" 0 0
48	if [ $? -ne $BSDDIALOG_OK ]; then
49		exit
50	else
51		[ -z "$MIRROR_BUTTON" ] || unset BSDINSTALL_DISTSITE
52		exec $0 $BSDINSTALL_CHROOT
53	fi
54}
55
56if [ -z "$1" ]; then
57	error "Directory can not be empty\n\nUsage:\nbsdinstall jail directory"
58fi
59export BSDINSTALL_CHROOT=$1
60
61rm -rf $BSDINSTALL_TMPETC
62mkdir $BSDINSTALL_TMPETC
63mkdir -p $1 || error "mkdir failed for $1"
64
65if [ -n "$SCRIPT" ]
66then
67        split -a 2 -p '^#!.*' "$SCRIPT" $TMPDIR/bsdinstall-installscript-
68        . $TMPDIR/bsdinstall-installscript-aa
69fi
70
71test ! -d $BSDINSTALL_DISTDIR && mkdir -p $BSDINSTALL_DISTDIR
72
73if [ ! -f $BSDINSTALL_DISTDIR/MANIFEST -a -z "$BSDINSTALL_DISTSITE" ]; then
74	exec 5>&1
75	BSDINSTALL_DISTSITE=$(`dirname $0`/mirrorselect 2>&1 1>&5)
76	MIRROR_BUTTON=$?
77	exec 5>&-
78	test $MIRROR_BUTTON -eq 0 || error "No mirror selected"
79	export BSDINSTALL_DISTSITE
80	fetch -o $BSDINSTALL_DISTDIR/MANIFEST $BSDINSTALL_DISTSITE/MANIFEST || error "Could not download $BSDINSTALL_DISTSITE/MANIFEST"
81fi
82
83: ${DISTRIBUTIONS="base.txz"}; export DISTRIBUTIONS
84if [ -f $BSDINSTALL_DISTDIR/MANIFEST ]; then
85	DISTMENU=`cut -f 4,5,6 $BSDINSTALL_DISTDIR/MANIFEST | grep -v -e ^kernel -e ^base`
86
87    if [ ! "$nonInteractive" == "YES" ]
88    then
89	    exec 5>&1
90	    EXTRA_DISTS=$(echo $DISTMENU | xargs -o bsddialog \
91	        --backtitle "$OSNAME Installer" \
92	        --title "Distribution Select" --no-cancel --separate-output \
93	        --checklist "Choose optional system components to install:" \
94	        0 0 0 \
95	    2>&1 1>&5)
96	    for dist in $EXTRA_DISTS; do
97	    	export DISTRIBUTIONS="$DISTRIBUTIONS $dist.txz"
98	    done
99    fi
100fi
101
102FETCH_DISTRIBUTIONS=""
103for dist in $DISTRIBUTIONS; do
104	if [ ! -f $BSDINSTALL_DISTDIR/$dist ]; then
105		FETCH_DISTRIBUTIONS="$FETCH_DISTRIBUTIONS $dist"
106	fi
107done
108FETCH_DISTRIBUTIONS=`echo $FETCH_DISTRIBUTIONS`	# Trim white space
109
110if [ -n "$FETCH_DISTRIBUTIONS" -a -z "$BSDINSTALL_DISTSITE" ]; then
111	exec 5>&1
112	BSDINSTALL_DISTSITE=$(`dirname $0`/mirrorselect 2>&1 1>&5)
113	MIRROR_BUTTON=$?
114	exec 5>&-
115	test $MIRROR_BUTTON -eq 0 || error "No mirror selected"
116	export BSDINSTALL_DISTSITE
117fi
118
119if [ ! -z "$FETCH_DISTRIBUTIONS" ]; then
120	bsdinstall distfetch || error "Failed to fetch distribution"
121fi
122
123bsdinstall checksum || error "Distribution checksum failed"
124bsdinstall distextract || error "Distribution extract failed"
125
126if [ ! "$nonInteractive" == "YES" ]
127then
128    bsdinstall rootpass || error "Could not set root password"
129fi
130
131trap true SIGINT	# This section is optional
132
133if [ ! "$nonInteractive" == "YES" ]
134then
135bsdinstall services
136
137    bsddialog --backtitle "$OSNAME Installer" --title "Add User Accounts" --yesno \
138        "Would you like to add users to the installed system now?" 0 0 && \
139        bsdinstall adduser
140fi
141
142trap error SIGINT	# SIGINT is bad again
143bsdinstall config  || error "Failed to save config"
144cp /etc/resolv.conf $1/etc
145cp /etc/localtime $1/etc
146cp /var/db/zoneinfo $1/var/db
147
148# Run post-install script
149if [ -f $TMPDIR/bsdinstall-installscript-ab ]; then
150	cp $TMPDIR/bsdinstall-installscript-ab $BSDINSTALL_CHROOT/tmp/installscript
151	chmod a+x $BSDINSTALL_CHROOT/tmp/installscript
152	mount -t devfs devfs "$BSDINSTALL_CHROOT/dev"
153	chroot $BSDINSTALL_CHROOT /tmp/installscript $@ 2>&1
154	umount "$BSDINSTALL_CHROOT/dev"
155	rm $BSDINSTALL_CHROOT/tmp/installscript
156fi
157
158bsdinstall entropy
159
160f_dprintf "Installation Completed at %s" "$(date)"
161exit $SUCCESS
162
163################################################################################
164# END
165################################################################################
166